﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TppGame.DecTree
{
    public class Assert : Node
    {
        Func<Character,bool> Predicate;

        public Assert(Func<Character, bool> predicate)
            : base()
        {
            Predicate = predicate;
        }

        public override Status Visit(Character ch)
        {
            if (Predicate != null && Predicate(ch))
                return Status.Success;
            else
                return Status.Fail;
        }        
    }
}
