﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Mogre;
using MogreNewt;

namespace TppGame
{
    class Level
    {
        Entity GraphicsEntity;
        SceneNode GraphicsNode;

        Entity CollisionEntity;
        SceneNode CollisionNode;

        Body Body;

        public void SetGraphicsMesh(String meshFile)
        {
            GraphicsNode =
                Engine.Singleton.SceneManager.RootSceneNode.CreateChildSceneNode();
            GraphicsEntity = Engine.Singleton.SceneManager.CreateEntity(meshFile);
            GraphicsNode.AttachObject(GraphicsEntity);
            GraphicsEntity.CastShadows = false;
        }

        public void SetCollisionMesh(String meshFile)
        {
            CollisionNode = 
                Engine.Singleton.SceneManager.RootSceneNode.CreateChildSceneNode();
            CollisionEntity = Engine.Singleton.SceneManager.CreateEntity(meshFile);
            CollisionNode.AttachObject(CollisionEntity);
 
            // Nie chcemy aby siatka kolizyjna była widoczna
            CollisionNode.SetVisible(false);

             MogreNewt.CollisionPrimitives.TreeCollisionSceneParser collision = 
                 new MogreNewt.CollisionPrimitives.TreeCollisionSceneParser(
                Engine.Singleton.NewtonWorld);
            collision.ParseScene(CollisionNode, true, 1);
            Body = new Body(Engine.Singleton.NewtonWorld, collision);
            collision.Dispose();
            Body.AttachNode(CollisionNode);
            Body.UserData = this;
            Body.MaterialGroupID = Engine.Singleton.MaterialManager.LevelMaterialID;
        }
    }
}
